ScriptName MystWeaponSpeedMCMScript Extends Ski_ConfigBase

Int OID_ModActive
Int OID_SpeedLimit
Int OID_GiveSpells

GlobalVariable Property WeaponSpeedLimitGlobal Auto ; Default = 2.00
GlobalVariable Property WeaponSpeedFixActiveGlobal Auto
Spell Property WeaponSpeedFixAbility Auto
Spell Property WeaponSpeed_GiveSelf Auto
Spell Property WeaponSpeed_GiveOther Auto

Event OnConfigRegister()
	Game.GetPlayer().AddSpell(WeaponSpeedFixAbility, False)
EndEvent

Event OnPageReset(String Page)

	If Page == ("")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("General")
		OID_ModActive = AddToggleOption("Weapon Speed Fix Active", (WeaponSpeedFixActiveGlobal.GetValue() as Int))
		AddHeaderOption("Settings")
		OID_SpeedLimit = AddSliderOption("Weapon Speed Limit", WeaponSpeedLimitGlobal.GetValue(), "{2}")
		AddHeaderOption("Utility Spells")
		OID_GiveSpells = AddToggleOption("Give Spells", (Game.GetPlayer().HasSpell(WeaponSpeed_GiveOther) as Int))
		AddHeaderOption("")
	EndIf
	
EndEvent

Function ToggleSpell(Actor Target, Spell TheSpell) ; Simple Toggle function to add and remove the spell from whomever it might concern if necessary.
	If Target.HasSpell(TheSpell)
		Debug.Trace("Removing spell " +TheSpell.GetName()+ " from " +Target)
		Target.RemoveSpell(TheSpell)
	Else
		Debug.Trace("Adding spell " +TheSpell.GetName()+ " to " +Target)
		Target.AddSpell(TheSpell, False)
	EndIf
EndFunction

Event OnOptionHighlight(Int Option)
	If (Option == OID_ModActive)
		SetInfoText("Enables/Disables Weapon Speed fix")
	ElseIf (Option == OID_SpeedLimit)
		SetInfoText("Numerical value of the weapon speed limit. The mod will attempt to dynamically modify weapon speed if it ever goes beyond this point.")
	ElseIf (Option == OID_GiveSpells)
		SetInfoText("Give the player spells to add or remove the effect from self and NPCs (NPCs get speed problems practically never, so this is only a What If? option just in case.")
	EndIf
EndEvent

Float Property SpeedLimitDefault = 2.00 Auto

Event OnOptionSliderOpen(Int Option)
	If (Option == OID_SpeedLimit)
		SetSliderDialogStartValue(WeaponSpeedLimitGlobal.GetValue())
		SetSliderDialogDefaultValue(SpeedLimitDefault)
		SetSliderDialogRange(1.00, 4.00)
		SetSliderDialogInterval(0.01)
	EndIf
EndEvent

Event OnOptionSliderAccept(Int Option, Float Value)
	If (Option == OID_SpeedLimit)
		WeaponSpeedLimitGlobal.SetValue(Value)
		SetSliderOptionValue(Option, Value, "{2}")
	EndIf
EndEvent

Event OnOptionSelect(Int Option)
	If (Option == OID_ModActive)
		If WeaponSpeedFixActiveGlobal.GetValue() == 1
			WeaponSpeedFixActiveGlobal.SetValue(0)
			SetToggleOptionValue(Option, 0)
		Else
			WeaponSpeedFixActiveGlobal.SetValue(1)
			SetToggleOptionValue(Option, 1)
		EndIf
	ElseIf (Option == OID_GiveSpells)
		If Game.GetPlayer().HasSpell(WeaponSpeed_GiveOther)
			Game.GetPlayer().RemoveSpell(WeaponSpeed_GiveSelf)
			Game.GetPlayer().RemoveSpell(WeaponSpeed_GiveOther)
			SetToggleOptionValue(Option, 0)
		Else
			Game.GetPlayer().AddSpell(WeaponSpeed_GiveSelf)
			Game.GetPlayer().AddSpell(WeaponSpeed_GiveOther)
			SetToggleOptionValue(Option, 1)
		EndIf
	EndIf
EndEvent

